package com.weaver.seconddev.interfaces.easoa;

import com.weaver.seconddev.interfaces.prop.ConfigProp;
import org.apache.axis2.transport.http.HttpTransportProperties;
import  com.weaver.seconddev.interfaces.easoa.SI_InterLoanApplicationSync_OUTServiceStub.InternalBorrowing;
import  com.weaver.seconddev.interfaces.easoa.SI_InterLoanApplicationSync_OUTServiceStub.InternalBorrowingService;
import  com.weaver.seconddev.interfaces.easoa.SI_InterLoanApplicationSync_OUTServiceStub.InternalBorrowingSynchronization;
import  com.weaver.seconddev.interfaces.easoa.SI_InterLoanApplicationSync_OUTServiceStub.ResultInfo;
import  com.weaver.seconddev.interfaces.easoa.SI_InterLoanApplicationSync_OUTServiceStub.ResultInfoLines;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import java.lang.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;

public class InterLoanService extends BaseBean {

    private static final org.slf4j.Logger logger_9c1a93c4 = LoggerFactory.getLogger(InterLoanService.class);
    @Autowired
    private ConfigProp configProp;
    public String[] call(InternalBorrowing[] info) {
        String[] str = new String[2];
//        String url = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("hteasoasync.InterLoan")).trim();
        String url = configProp.getInterLoan();
        try {
            logger_9c1a93c4.info(String.valueOf("调用报账系统内部借款接口开始"));
            SI_InterLoanApplicationSync_OUTServiceStub stub = new SI_InterLoanApplicationSync_OUTServiceStub(url);
            stub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.CHUNKED, Boolean.FALSE);
            stub._getServiceClient().getOptions().setTimeOutInMilliSeconds(300000);
            HttpTransportProperties.Authenticator auth = new HttpTransportProperties.Authenticator();
//            auth.setUsername(Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.po_user")).trim());
//            auth.setPassword(Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.po_password")).trim());

            auth.setUsername(configProp.getPo_user());
            auth.setPassword(configProp.getPo_password());
            stub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.AUTHENTICATE, auth);
            InternalBorrowingService res = new InternalBorrowingService();
            InternalBorrowingSynchronization param = new InternalBorrowingSynchronization();
            param.setITFID("HT01BZ023");
            param.setSENDID("");
            param.setSYSID("SYS006");
            param.setInternalBorrowing(info);
            res.setInternalBorrowingSynchronization(param);
            SI_InterLoanApplicationSync_OUTServiceStub.InternalBorrowingServiceResponse rep = stub.sI_InterLoanApplicationSync_OUT(res);
            ResultInfo result = rep.get_return();
            str[0] = result.getISTAT();
            if ("1".equals(str[0])) {
                str[1] = result.getMESSAGE();
            } else {
                ResultInfoLines[] lines = rep.get_return().getResultInfoLinesArr();
                str[1] = lines[0].getMESSAGE();
            }
            logger_9c1a93c4.info(String.valueOf("调用报账系统内部借款接口返回结果：" + str[0] + "--" + str[1]));
            logger_9c1a93c4.info(String.valueOf("调用报账系统内部借款接口结束"));
        } catch (Exception e) {
            str[0] = "0";
            str[1] = e.toString();
            logger_9c1a93c4.info(String.valueOf("调用报账系统内部借款接口出错：" + e.toString()));
        }
        return str;
    }
}
