package com.weaver.seconddev.interfaces.swfa.sl;

import com.weaver.seconddev.interfaces.prop.ConfigProp;
import net.sf.json.JSONObject;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.rmi.RemoteException;
import java.security.MessageDigest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map.Entry;
import java.util.Set;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.env.Environment;
import java.lang.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;

/**
 * Webs ???ò??????
 * @author Administrator
 */
public class CallSLServices extends BaseBean {

	private static final org.slf4j.Logger logger_6fef4f91 = LoggerFactory.getLogger(CallSLServices.class);

	private HashMap errandBill = null;

	private ArrayList<HashMap> journey = null;

	private ArrayList<HashMap> companionInfo = null;

	private HashMap extInfo = null;

	private CreateBillSrvStub.ErrandBillInfo errandBill1 = null;

	private CreateBillSrvStub.JourneyInfo[] journeys = null;

	private CreateBillSrvStub.MapString[] extInfos = null;

	private CreateBillSrvStub.CompanionInfo[] companionInfos = null;

	public void setErrandBillInfo(HashMap errand) {
		this.errandBill = errand;
	}

	public void setJourneyInfo(ArrayList<HashMap> journey) {
		this.journey = journey;
	}

	public void setCompanionInfo(ArrayList<HashMap> companionInfo) {
		this.companionInfo = companionInfo;
	}

	public void setMapString(HashMap extInfo) {
		this.extInfo = extInfo;
	}
	@Autowired
	private ConfigProp configProp;
	// 调用中兴接口
	public String[] call() throws RemoteException {
		CreateBillSrvStub stub = null;
		// String wsdlLocation = GetServicesURL();
//		String wsdlLocation = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htsloasync.ServicesURL")).trim();
		String wsdlLocation = configProp.getServicesURL();
		stub = new CreateBillSrvStub(wsdlLocation);
		stub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.CHUNKED, Boolean.FALSE);
		CreateBillSrvStub.CreateBillRequest createBillRequest = new CreateBillSrvStub.CreateBillRequest();
		Date now = new Date();
		CreateBillSrvStub.ErrandBillInfo bill = new CreateBillSrvStub.ErrandBillInfo();
		// 封装单据主信息
		// 封装单据主信息
		if (errandBill != null && !errandBill.isEmpty()) {
			Set<Entry<String, String>> sets = errandBill.entrySet();
			for (Entry<String, String> entry : sets) {
				if (entry.getKey().equals("sourceType")) {
					bill.setSourceType(entry.getValue().toString());
				}
				if (entry.getKey().equals("sourceKey")) {
					bill.setSourceKey(entry.getValue().toString());
				}
				if (entry.getKey().equals("applyEmpNum")) {
					bill.setApplyEmpNum(entry.getValue().toString());
				}
				if (entry.getKey().equals("errandEmpNum")) {
					bill.setErrandEmpNum(entry.getValue().toString());
				}
				if (entry.getKey().equals("projectCode")) {
					bill.setProjectCode(entry.getValue().toString());
				}
				if (entry.getKey().equals("journeyType")) {
					bill.setJourneyType(entry.getValue().toString());
				}
				if (entry.getKey().equals("corporation")) {
					bill.setCorporation(entry.getValue().toString());
				}
				if (entry.getKey().equals("costCentre")) {
					bill.setCostCentre(entry.getValue().toString());
				}
				if (entry.getKey().equals("contactName")) {
					bill.setContactName(entry.getValue().toString());
				}
				if (entry.getKey().equals("contactPhone")) {
					bill.setContactPhone(entry.getValue().toString());
				}
				if (entry.getKey().equals("contactEmail")) {
					bill.setContactEmail(entry.getValue().toString());
				}
				if (entry.getKey().equals("trafficExpense")) {
					bill.setTrafficExpense(entry.getValue().toString());
				}
				if (entry.getKey().equals("hotelExpense")) {
					bill.setHotelExpense(entry.getValue().toString());
				}
				if (entry.getKey().equals("otherExpense")) {
					bill.setOtherExpense(entry.getValue().toString());
				}
				if (entry.getKey().equals("reason")) {
					bill.setReason(entry.getValue().toString());
				}
			}
		}
		// 封装行程信息
		if (journey != null && journey.size() > 0) {
			journeys = new CreateBillSrvStub.JourneyInfo[journey.size()];
			for (int i = 0; i < journey.size(); i++) {
				CreateBillSrvStub.JourneyInfo ji = new CreateBillSrvStub.JourneyInfo();
				HashMap hjs = journey.get(i);
				if (!hjs.isEmpty()) {
					Set<Entry<String, String>> sets = hjs.entrySet();
					for (Entry<String, String> entry : sets) {
						if (entry.getKey().equals("seqNo")) {
							ji.setSeqNo(entry.getValue().toString());
						}
						if (entry.getKey().equals("fromCity")) {
							ji.setFromCity(entry.getValue().toString());
						}
						if (entry.getKey().equals("toCity")) {
							ji.setToCity(entry.getValue().toString());
						}
						if (entry.getKey().equals("journeyType")) {
							ji.setJourneyType(entry.getValue().toString());
						}
						if (entry.getKey().equals("areaType")) {
							ji.setAreaType(entry.getValue().toString());
						}
						if (entry.getKey().equals("trafficTool")) {
							ji.setTrafficTool(entry.getValue().toString());
						}
						if (entry.getKey().equals("startDate")) {
							ji.setStartDate(entry.getValue().toString());
						}
						if (entry.getKey().equals("endDate")) {
							ji.setEndDate(entry.getValue().toString());
						}
					}
				}
				journeys[i] = ji;
			}
		}
		// 封装同行人信息
		if (companionInfo != null && companionInfo.size() > 0) {
			companionInfos = new CreateBillSrvStub.CompanionInfo[companionInfo.size()];
			for (int i = 0; i < companionInfo.size(); i++) {
				HashMap hjs = companionInfo.get(i);
				CreateBillSrvStub.CompanionInfo ci = new CreateBillSrvStub.CompanionInfo();
				if (!hjs.isEmpty()) {
					Set<Entry<String, String>> sets = hjs.entrySet();
					for (Entry<String, String> entry : sets) {
						if (entry.getKey().equals("personnelType")) {
							// writeLog("personnelType："+i+" "+entry.getValue().toString() );
							ci.setPersonnelType(entry.getValue().toString());
						}
						if (entry.getKey().equals("empNum")) {
							// writeLog("empNum："+i+" "+entry.getValue().toString() );
							ci.setEmpNum(entry.getValue().toString());
						}
						if (entry.getKey().equals("personnelName")) {
							// writeLog("personnelName："+i+" "+entry.getValue().toString() );
							ci.setPersonnelName(entry.getValue().toString());
						}
						if (entry.getKey().equals("passName")) {
							// writeLog("passName："+i+" "+entry.getValue().toString() );
							ci.setPassName(entry.getValue().toString());
						}
						if (entry.getKey().equals("passType")) {
							// writeLog("passType："+i+" "+entry.getValue().toString() );
							ci.setPassType(entry.getValue().toString());
						}
						if (entry.getKey().equals("passNum")) {
							// writeLog("passNum："+i+" "+entry.getValue().toString() );
							ci.setPassNum(entry.getValue().toString());
						}
						if (entry.getKey().equals("mobilePhone")) {
							// writeLog("mobilePhone："+i+" "+entry.getValue().toString() );
							ci.setMobilePhone(entry.getValue().toString());
						}
						if (entry.getKey().equals("email")) {
							// writeLog("email："+i+" "+entry.getValue().toString() );
							ci.setEmail(entry.getValue().toString());
						}
					}
				}
				companionInfos[i] = ci;
			}
		}
		// 封装扩展信息
		String requestId = "";
		if (!extInfo.isEmpty()) {
			Set<Entry<String, String>> sets = extInfo.entrySet();
			if (sets != null && sets.size() > 0) {
				extInfos = new CreateBillSrvStub.MapString[sets.size()];
				int i = 0;
				for (Entry<String, String> entry : sets) {
					CreateBillSrvStub.MapString ms = new CreateBillSrvStub.MapString();
					for (int m = 2; m <= 20; m++) {
						if (entry.getKey().equals("attribute" + m)) {
							if (("attribute" + m).equals("attribute2")) {
								if (entry.getValue().toString() != null && entry.getValue().toString().isEmpty() == false) {
									requestId = entry.getValue().toString();
								} else {
									;
								}
							}
							ms.setKey("attribute" + m);
							ms.setValue(entry.getValue().toString());
						}
					}
					extInfos[i] = ms;
					i++;
				}
			}
		}
		bill.setJourneyInfos(journeys);
		bill.setCompanionInfos(companionInfos);
		bill.setExtInfo(extInfos);
		createBillRequest.setErrandBillInfo(bill);
		// 设置日期格式
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date da = new Date();
//		String username = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htsloasync.UserName")).trim();
//		String key = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htsloasync.Key")).trim();
		String username = configProp.getUserName();
		String key = configProp.getKey();
		createBillRequest.setCurrentTime(df.format(da));
		// createBillRequest.setUserName(GetUserName());
		// String password = GetUserName()+bill.getSourceType()+bill.getSourceKey()+df.format(new Date())+GetKey();
		createBillRequest.setUserName(username);
		String password = username + bill.getSourceType() + bill.getSourceKey() + df.format(new Date()) + key;
		password = toMD5(password).toUpperCase();
		createBillRequest.setPassword(password);
		// 调用接口前将数据保存至日志表
		// 获取并保存表头
		RecordSet rsErrandBillReques = I18nContextUtil.getBean(RecordSet.class);
		String strErrandBillReques = String.format("INSERT INTO [HTErrandBillRequest] ([requestId], [userName], [currentTime], [password],[sendTime]) VALUES ('%s','%s', '%s','%s','%s')", ToChar(requestId), ToChar(username), df.format(new Date()), password, df.format(da));
		String poolname = CONN_TYPE.workflow.getType();
		// TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
		rsErrandBillReques.executeSql(strErrandBillReques, poolname);
		// 获取并保存表单主信息
		RecordSet rsBill = I18nContextUtil.getBean(RecordSet.class);
		String strBill = String.format("INSERT INTO [HTErrandBillInfo] ([requestId], [sourceType], [sourceKey], [applyEmpNum], [errandEmpNum], [projectCode], [journeyType], [corporation], [costCentre], [contactName], [contactPhone],[contactEmail], [trafficExpense], [hotelExpense], [otherExpense], [reason],[sendTime]) VALUES ('%s','%s', '%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')", ToChar(requestId), ToChar(bill.getSourceType()), ToChar(bill.getSourceKey()), ToChar(bill.getApplyEmpNum()), ToChar(bill.getErrandEmpNum()), ToChar(bill.getProjectCode()), ToChar(bill.getJourneyType()), ToChar(bill.getCorporation()), ToChar(bill.getCostCentre()), ToChar(bill.getContactName()), ToChar(bill.getContactPhone()), ToChar(bill.getContactEmail()), ToChar(bill.getTrafficExpense()), ToChar(bill.getHotelExpense()), ToChar(bill.getOtherExpense()), ToChar(bill.getReason()), df.format(da));
		String poolname_zm = CONN_TYPE.workflow.getType();
		// TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
		rsBill.executeSql(strBill, poolname_zm);
		// 获取并保存行程信息
		RecordSet rsjourney;
		if (journeys != null && journeys.length > 0) {
			for (int i = 0; i < journeys.length; i++) {
				rsjourney = I18nContextUtil.getBean(RecordSet.class);
				CreateBillSrvStub.JourneyInfo jour = journeys[i];
				String strjourney = String.format("INSERT INTO [HTJourneyInfo] ([requestId], [seqNo], [fromCity], [toCity], [journeyType], [areaType], [trafficTool], [startDate], [endDate],[sendTime]) VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')", ToChar(requestId), ToChar(jour.getSeqNo()), ToChar(jour.getFromCity()), ToChar(jour.getToCity()), ToChar(jour.getJourneyType()), ToChar(jour.getAreaType()), ToChar(jour.getTrafficTool()), jour.getStartDate(), jour.getEndDate(), df.format(da));
				String poolname_90 = CONN_TYPE.workflow.getType();
				// TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
				rsjourney.executeSql(strjourney, poolname_90);
			}
		}
		// 获取并保存同行人信息
		RecordSet rsCompanionInfo;
		if (companionInfos != null && companionInfos.length > 0) {
			for (int i = 0; i < companionInfos.length; i++) {
				rsCompanionInfo = I18nContextUtil.getBean(RecordSet.class);
				CreateBillSrvStub.CompanionInfo cInfo = companionInfos[i];
				String strCompanionInfo = String.format("INSERT INTO [HTCompanionInfo] ([requestId], [personnelType], [empNum], [personnelName], [passName], [passType], [passNum], [mobilePhone], [email],[sendTime]) VALUES ('%s','%s','%s','%s','%s','%s','%s','%s' ,'%s','%s')", ToChar(requestId), ToChar(cInfo.getPersonnelType()), ToChar(cInfo.getEmpNum()), ToChar(cInfo.getPersonnelName()), ToChar(cInfo.getPassName()), ToChar(cInfo.getPassType()), ToChar(cInfo.getPassNum()), ToChar(cInfo.getMobilePhone()), ToChar(cInfo.getEmail()), df.format(da));
				String poolname_kk = CONN_TYPE.workflow.getType();
				// TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
				rsCompanionInfo.executeSql(strCompanionInfo, poolname_kk);
			}
		}
		// 获取并保存同行人信息
		RecordSet rsMapString;
		String attribute1 = "";
		String attribute2 = "";
		String attribute3 = "";
		String attribute4 = "";
		String attribute5 = "";
		String attribute6 = "";
		String attribute7 = "";
		String attribute8 = "";
		String attribute9 = "";
		String attribute10 = "";
		String attribute11 = "";
		String attribute12 = "";
		String attribute13 = "";
		String attribute14 = "";
		String attribute15 = "";
		String attribute16 = "";
		String attribute17 = "";
		String attribute18 = "";
		String attribute19 = "";
		String attribute20 = "";
		if (extInfos != null && extInfos.length > 0) {
			rsMapString = I18nContextUtil.getBean(RecordSet.class);
			for (int i = 0; i < extInfos.length; i++) {
				CreateBillSrvStub.MapString mString = extInfos[i];
				if (mString.getKey().equals("attribute2")) {
					attribute2 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute3")) {
					attribute3 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute4")) {
					attribute4 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute5")) {
					attribute5 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute6")) {
					attribute6 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute7")) {
					attribute7 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute8")) {
					attribute8 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute9")) {
					attribute9 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute10")) {
					attribute10 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute11")) {
					attribute11 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute12")) {
					attribute12 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute13")) {
					attribute13 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute14")) {
					attribute14 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute15")) {
					attribute15 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute16")) {
					attribute16 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute17")) {
					attribute17 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute18")) {
					attribute18 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute19")) {
					attribute19 = mString.getValue().toString();
				}
				if (mString.getKey().equals("attribute20")) {
					attribute20 = mString.getValue().toString();
				}
			}
			String strString = String.format("INSERT INTO [HTMapString] ([requestId], [attribute1], [attribute2], [attribute3], [attribute4], [attribute5], [attribute6], [attribute7], [attribute8], [attribute9], [attribute10], [attribute11], [attribute12], [attribute13], [attribute14], [attribute15], [attribute16], [attribute17], [attribute18], [attribute19], [attribute20], [useType],[sendTime]) VALUES ('%s','%s', '%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s', '%s','%s')", ToChar(requestId), ToChar(attribute1), ToChar(attribute2), ToChar(attribute3), ToChar(attribute4), ToChar(attribute5), ToChar(attribute6), ToChar(attribute7), ToChar(attribute8), ToChar(attribute9), ToChar(attribute10), ToChar(attribute11), ToChar(attribute12), ToChar(attribute13), ToChar(attribute14), ToChar(attribute15), ToChar(attribute16), ToChar(attribute17), ToChar(attribute18), ToChar(attribute19), ToChar(attribute20), "1", df.format(da));
			String poolname_yi = CONN_TYPE.workflow.getType();
			// TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
			rsMapString.executeSql(strString, poolname_yi);
		}
		// writeLog("调用接口------------------------开始");
		CreateBillSrvStub.CreateBillResponse resp = null;
		resp = stub.process(createBillRequest);
		// writeLog("调用接口------------------------完成");
		// 封装返回
		String[] rtInfo = new String[4];
		rtInfo[0] = resp.getReturnCode();
		rtInfo[1] = resp.getErrorMessage();
		rtInfo[2] = resp.getReturnPassword();
		rtInfo[3] = resp.getErrandBillNum();
		// writeLog("开始记录返回数据------------------------");
		// 将返回结果记录日志表
		RecordSet rsErrandBillResponse = I18nContextUtil.getBean(RecordSet.class);
		String strErrandBillResponse = String.format("INSERT INTO [HTErrandBillResponse] ([requestId], [returnCode], [errorMessage], [returnPassword], [errandBillNum],[sendTime]) VALUES ('%s','%s','%s','%s','%s','%s')", requestId, resp.getReturnCode(), resp.getErrorMessage(), resp.getReturnPassword(), resp.getErrandBillNum(), df.format(da));
		String poolname_co = CONN_TYPE.workflow.getType();
        /*writeLog("待执行的SQL------"+strErrandBillResponse);
 TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源*/
		rsErrandBillResponse.executeSql(strErrandBillResponse, poolname_co);
		// writeLog("完成记录返回数据------------------------");
		return rtInfo;
	}

	public String ToChar(String s) {
		// System.out.println("s转义前："+s);
		if (s != null) {
			s = s.replace("'", "\''");
		}
		// System.out.println("s转义后："+s);
		return s;
	}

	public String toMD5(String plainText) {
		StringBuffer buf = new StringBuffer("");
		try {
			// 生成实现指定摘要算法的 MessageDigest 对象。
			MessageDigest md = MessageDigest.getInstance("MD5");
			// 使用指定的字节数组更新摘要。
			md.update(plainText.getBytes());
			// 通过执行诸如填充之类的最终操作完成哈希计算。
			byte[] b = md.digest();
			// 生成具体的md5密码到buf数组
			int i;
			// StringBuffer buf = new StringBuffer("");
			for (int offset = 0; offset < b.length; offset++) {
				i = b[offset];
				if (i < 0) {
					i += 256;
				}
				if (i < 16) {
					buf.append("0");
				}
				buf.append(Integer.toHexString(i));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return buf.toString();
	}

	// 获取用户名
	private String GetUserName() {
		ConfigModel config = GetConfigModel();
		if (config != null) {
			String url = config.getUserName();
			return url;
		}
		return "";
	}

	// 获取用户名
	private String GetKey() {
		ConfigModel config = GetConfigModel();
		if (config != null) {
			String url = config.getKey();
			return url;
		}
		return "";
	}

	// 获取Webservice服务地址
	private String GetServicesURL() {
		ConfigModel config = GetConfigModel();
		if (config != null) {
			String url = config.getServicesURL();
			return url;
		}
		return "";
	}

	// 获取数据库连接字符串
	private String GetDBConnection() {
		ConfigModel config = GetConfigModel();
		if (config != null) {
			return config.getDBConnection();
		}
		return "";
	}

	private String GetCourseFile() {
		String path = CallSLServices.class.getResource("/").getPath();
		try {
			path = URLDecoder.decode(path, "utf-8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return path;
	}

	private ConfigModel GetConfigModel() {
		logger_6fef4f91.info(String.valueOf("json打印1---------------------"));
		String courseFile = GetCourseFile();
		String path = courseFile + "config.json";
		//TODO config

//		String jsonStr = FileUtil.ReadFile(path);
		String jsonStr = "";
		JSONObject jsonObject = JSONObject.fromObject(jsonStr);
		logger_6fef4f91.info("config.getServicesURL()==" + jsonObject.toString());
		if (jsonObject != null && jsonObject.isEmpty() == false) {
			ConfigModel config = new ConfigModel();
			config.setServicesURL(jsonObject.getString("ServicesURL"));
			config.setDBConnection(jsonObject.getString("DBConnection"));
			config.setUserName(jsonObject.getString("UserName"));
			config.setKey(jsonObject.getString("Key"));
			//
			// ConfigModel config = (ConfigModel) JSONObject.toBean(jsonObject,
			// ConfigModel.class);
			// if(config!=null&&config.getServicesURL()!=null){
			// WriteLog("config.getServicesURL()!=null");
			//
			// WriteLog("config.getServicesURL()=="+config.getServicesURL());
			//
			// }else{
			//
			// WriteLog("config.getServicesURL()==null");
			// }
			return config;
		}
		return null;
	}
}
