package com.weaver.seconddev.interfaces.workflow.action;

import java.util.HashMap;
import java.util.Map;
import  com.weaver.seconddev.interfaces.srmoa.CallVdDlvApplyServices;
import  com.weaver.seconddev.interfaces.srmoa.VdDlvApplyHandlerServiceServiceStub;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import com.weaver.verupgrade.common.DateUtil;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.hrm.company.DepartmentComInfo;
import com.weaver.verupgrade.hrm.resource.ResourceComInfo;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_AddSupplyToSrmCheckAction")
public class AddSupplyToSrmCheckAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_75ae129c = LoggerFactory.getLogger(AddSupplyToSrmCheckAction.class);

    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            logger_75ae129c.info(String.valueOf("do AddSupplyToSrmCheckAction on request:" + request.getRequestid()));
            try {
                // 获取主表数据
                String requestid = request.getRequestid();
                ResourceComInfo resourcecominfo = I18nContextUtil.getBean(ResourceComInfo.class);
                DepartmentComInfo departmentComInfo = I18nContextUtil.getBean(DepartmentComInfo.class);
                String state = "E";
                String message = "";
                Map<String, String> map = new HashMap<String, String>();
                Property[] aproperty = request.getMainTableInfo().getProperty();
                for (int i = 0; i < aproperty.length; i++) {
                    String name = aproperty[i].getName().toUpperCase();
                    String value = Util.null2String(aproperty[i].getValue());
                    map.put(name, value);
                }
                String xsxx = String.valueOf(map.get("XSXX"));
                String val = BillFieldUtil.getselectName(xsxx, "37482");
                logger_75ae129c.info(String.valueOf("AddSupplyToSrmCheckAction--线上/线下供应商:" + val));
                if (val.length() > 1) {
                    val = val.substring(0, 1);
                }
                if (val.equals("0")) {
                    // 流程编号
                    String lcbh = String.valueOf(map.get("LCBH"));
                    // 公司编码
                    String sqdwbm = String.valueOf(map.get("SQDWBM"));
                    // 公司名称
                    String sqdw = String.valueOf(map.get("SQDW"));
                    // 供应商编码
                    String gysbm = String.valueOf(map.get("GYSBM"));
                    // 供应商名称
                    String gysmc = String.valueOf(map.get("GYSMC"));
                    // 申请人
                    String sqr = String.valueOf(map.get("SQR"));
                    // 申请人工号
                    String gh = String.valueOf(map.get("GH"));
                    // 主供品类
                    String gycpmc = String.valueOf(map.get("GYCPMC"));
                    // 审核时间
                    String date = DateUtil.getFullDate();
                    // 引入后预计达到的目的
                    String yrhyqdddxg = String.valueOf(map.get("YRHYQDDDXG"));
                    // 申请原因
                    String yryy = String.valueOf(map.get("YRYY"));
                    // 预计年度将本金额
                    String yjndcbjsje = String.valueOf(map.get("YJNDCBJSJE"));
                    // 现场审核 	0：不需要；1：需要；
                    int xcsh = 0;
                    if ("0".equals(String.valueOf(map.get("XCSH")))) {
                        xcsh = 1;
                    }
                    if ("1".equals(String.valueOf(map.get("XCSH")))) {
                        xcsh = 0;
                    }
                    // 申请部门
                    String sqbm = String.valueOf(map.get("SQBM"));
                    // 现有合格供应商
                    String xyhggys = String.valueOf(map.get("XYHGGYS"));
                    VdDlvApplyHandlerServiceServiceStub.DlvApplyIn dlvapplyin = new VdDlvApplyHandlerServiceServiceStub.DlvApplyIn();
                    dlvapplyin.setRequestId(Integer.parseInt(requestid));
                    dlvapplyin.setApplyNo(lcbh);
                    dlvapplyin.setCompanyCode(sqdwbm);
                    dlvapplyin.setCompanyName(sqdw);
                    dlvapplyin.setVendorCode(gysbm);
                    dlvapplyin.setVendorName(gysmc);
                    dlvapplyin.setApplyer(resourcecominfo.getResourcename(sqr));
                    dlvapplyin.setEmpNo(gh);
                    dlvapplyin.setCategoryName(gycpmc);
                    dlvapplyin.setCheckUserName(resourcecominfo.getResourcename(request.getLastoperator()));
                    dlvapplyin.setCheckTime(date);
                    dlvapplyin.setApplyReason(yryy);
                    dlvapplyin.setExpectedMoney(yjndcbjsje);
                    dlvapplyin.setExpectedPurpose(yrhyqdddxg);
                    // 提交标记(0：校验； 1：提交)
                    dlvapplyin.setSubmitFlag(0);
                    dlvapplyin.setDept(departmentComInfo.getDepartmentName(sqbm));
                    dlvapplyin.setVendors(xyhggys);
                    dlvapplyin.setInspectFlag(xcsh);
                    CallVdDlvApplyServices service = new CallVdDlvApplyServices();
                    service.setOainputvendor(dlvapplyin);
                    String[] result = service.call();
                    state = result[0];
                    message = result[1];
                } else {
                    state = "S";
                }
                if (!"S".equals(state)) {
                    request.getRequestManager().setMessageid("ERROR");
                    request.getRequestManager().setMessagecontent(message);
                    return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
                }
            } catch (Exception e) {
                logger_75ae129c.info(String.valueOf(e.getMessage()));
                request.getRequestManager().setMessageid("AddSupplyToSrmCheckAction ERROR");
                request.getRequestManager().setMessagecontent(e.getMessage());
                return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
            }
            logger_75ae129c.info(String.valueOf("do AddSupplyToSrmCheckAction success!"));
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_75ae129c.error("AddSupplyToSrmCheckAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager())), request.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
