package com.weaver.seconddev.interfaces.workflow.action;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import  com.weaver.seconddev.interfaces.oames.ReturnMesWLPS_SYService;
import  com.weaver.seconddev.interfaces.oames.SI_OA_HTOAApproFlowSync_OUTServiceStub;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import org.springframework.core.env.Environment;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.hrm.resource.ResourceComInfo;
import com.weaver.verupgrade.soa.workflow.request.*;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

/**
 * HTGD-ZG04-亨通光导质量异常处理流程 回调
 */
@org.springframework.stereotype.Service("workflow_action_HTGD_MES_ZG04ReturnAction")
public class HTGD_MES_ZG04ReturnAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_5763d172 = LoggerFactory.getLogger(HTGD_MES_ZG04ReturnAction.class);

    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo requestinfo = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestId = requestinfo.getRequestid();
            try {
                String requestName = requestinfo.getRequestManager().getRequestname();
                String creatorId = requestinfo.getCreatorid();
                // 工作流ID
                String workFlowId = requestinfo.getWorkflowid();
                BillFieldUtil util = new BillFieldUtil();
                String tablename = util.getTablename(workFlowId);
                ResourceComInfo rsCom = I18nContextUtil.getBean(ResourceComInfo.class);
                logger_5763d172.info(String.valueOf("HTGD_MES_ZG04ReturnAction-start-" + requestId));
                logger_5763d172.info(String.valueOf("获取requestId:=" + requestId));
                Property[] properties = requestinfo.getMainTableInfo().getProperty();
                Map<String, String> mMap = new HashMap<String, String>();
                for (int i = 0; i < properties.length; i++) {
                    String name = properties[i].getName().toUpperCase();
                    String value = Util.null2String(properties[i].getValue());
                    mMap.put(name, value);
                }
                String lcbh = mMap.get("LCBH");
                logger_5763d172.info(String.valueOf("流程编号:" + lcbh));
                JSONObject mJson = new JSONObject();
                mJson.put("procId", requestId);
                mJson.put("procNo", lcbh);
                JSONArray reqArr = new JSONArray();
                reqArr.add(mJson);
                logger_5763d172.info(requestId + "-request info:" + reqArr.toString());
                Map<String, String> params = new HashMap<String, String>();
                params.put("params", reqArr.toString());
                // 调用接口
                // "http://10.6.105.25:8180/mes/oa/OaAuditResult.html";//
                String url = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htmesoasync.GDZG04OaAuditResult")).trim();
                SendPostRequest_param mGetResult = new SendPostRequest_param();
                // reqArr.toString()
                String result = mGetResult.getResult(params, url);
                logger_5763d172.info(String.valueOf(requestId + "-HTGD_MES_ZG04ReturnAction info:" + result));
                if (!"E".equals(result)) {
                    JSONArray arr = JSONArray.parseArray(result);
                    if (arr != null && arr.size() > 0) {
                        JSONObject returnJson = (JSONObject) arr.get(0);
                        String errorMessage = returnJson.getString("errorMessage");
                        // 处理消息
                        String message = returnJson.getString("result");
                        // 接口处理状态 1-失败，0-成功
                        String resultCode = returnJson.getString("resultCode");
                        if (!"0".equals(resultCode)) {
                            RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                            String poolname_zg = CONN_TYPE.workflow.getType();
                            // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                            rs.executeSql("update " + tablename + " set hxzt='E',fhxx='" + errorMessage + "' where requestId=" + requestId, poolname_zg);
                            requestinfo.getRequestManager().setMessagecontent("mes返回错误信息：" + errorMessage);
                            return WeaResult.fail(500, "执行失败", getResultMapForAction(weaverResultMap, "result", Action.FAILURE_AND_CONTINUE, requestinfo.getRequestManager()));
                        } else {
                            RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                            String poolname = CONN_TYPE.workflow.getType();
                            // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                            rs.executeSql("update " + tablename + " set hxzt='S',fhxx='" + message + "' where requestId=" + requestId, poolname);
                        }
                    }
                } else {
                    logger_5763d172.info(String.valueOf("调用光导mes系统接口返回失败，请联系mes系统管理员！"));
                    // requestInfo.getRequestManager().setMessageid("ERROR");
                    requestinfo.getRequestManager().setMessagecontent("调用光导mes系统接口返回失败，请联系mes系统管理员！");
                    return WeaResult.fail(500, "执行失败", getResultMapForAction(weaverResultMap, "result", Action.FAILURE_AND_CONTINUE, requestinfo.getRequestManager()));
                }
            } catch (Exception exception) {
                logger_5763d172.info(String.valueOf(requestId + "-HTGD_MES_ZG04ReturnAction error:" + exception.getMessage()));
                // requestInfo.getRequestManager().setMessageid("ERROR");
                requestinfo.getRequestManager().setMessagecontent("提交失败！");
                return WeaResult.fail(500, "执行失败", getResultMapForAction(weaverResultMap, "result", Action.FAILURE_AND_CONTINUE, requestinfo.getRequestManager()));
            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestinfo.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_5763d172.error("HTGD_MES_ZG04ReturnAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), requestinfo.getRequestManager())), requestinfo.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
