package com.weaver.seconddev.interfaces.workflow.action;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import  com.weaver.seconddev.interfaces.oames.ReturnMesWLPS_SYService;
import  com.weaver.seconddev.interfaces.oames.SI_OA_HTOAApproFlowSync_OUTServiceStub;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.hrm.resource.ResourceComInfo;
import com.weaver.verupgrade.soa.workflow.request.*;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.soa.workflow.request.DetailTable;
import com.weaver.verupgrade.soa.workflow.request.Row;
import com.weaver.verupgrade.soa.workflow.request.Cell;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

/**
 * HTLL-ZL01,HTLL-ZL02,HTLL-ZL03
 */
@org.springframework.stereotype.Service("workflow_action_HTLLUnqualifiedApprovalAction")
public class HTLLUnqualifiedApprovalAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_f1407471 = LoggerFactory.getLogger(HTLLUnqualifiedApprovalAction.class);

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo requestInfo = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestId = requestInfo.getRequestid();
            logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "开始执行"));
            // 工作流ID
            String workFlowId = requestInfo.getWorkflowid();
            BillFieldUtil util = new BillFieldUtil();
            String tablename = util.getTablename(workFlowId);
            try {
                String requestName = requestInfo.getRequestManager().getRequestname();
                String creatorId = requestInfo.getCreatorid();
                Map<String, String> map = new HashMap<String, String>();
                Property[] aproperty = requestInfo.getMainTableInfo().getProperty();
                for (int j = 0; j < aproperty.length; j++) {
                    String name = aproperty[j].getName().toUpperCase();
                    String value = Util.null2String(aproperty[j].getValue());
                    map.put(name, value);
                }
                ResourceComInfo rsCom = I18nContextUtil.getBean(ResourceComInfo.class);
                // 处理结果选择--
                String fxzt = map.get("XLYJ");
                if ("0".equals(fxzt)) {
                    // 转序
                    fxzt = "10";
                } else if ("1".equals(fxzt)) {
                    // 降级使用
                    fxzt = "11";
                } else if ("2".equals(fxzt)) {
                    // 报废
                    fxzt = "14";
                } else if ("3".equals(fxzt)) {
                    // 降级使用
                    fxzt = "12";
                } else if ("4".equals(fxzt)) {
                    // 返工返修
                    fxzt = "13";
                } else if ("5".equals(fxzt)) {
                    // 留用
                    fxzt = "0";
                } else if ("6".equals(fxzt)) {
                    // 留用考核
                    fxzt = "1";
                } else if ("7".equals(fxzt)) {
                    // 退货考核
                    fxzt = "2";
                } else if ("8".equals(fxzt)) {
                    // 重新生产
                    fxzt = "20";
                }
                // 质量问题描述
                String zzpdjg = map.get("ZLWTMS");
                // 原因分析
                String yyfx = map.get("YYFX");
                // 纠正措施
                String jzcs = map.get("JZCS");
                // 评审意见
                String psyj = map.get("PSYJ");
                // 填报责任人
                String tbzrr = map.get("TBZRR");
                String uuid = UUID.randomUUID().toString();
                ReturnMesWLPS_SYService service = new ReturnMesWLPS_SYService();
                SI_OA_HTOAApproFlowSync_OUTServiceStub.WLPS_SY_Request req = new SI_OA_HTOAApproFlowSync_OUTServiceStub.WLPS_SY_Request();
                SI_OA_HTOAApproFlowSync_OUTServiceStub.ArrayOfWLPS_SY_Main mainData = new SI_OA_HTOAApproFlowSync_OUTServiceStub.ArrayOfWLPS_SY_Main();
                SI_OA_HTOAApproFlowSync_OUTServiceStub.WLPS_SY_Main param = new SI_OA_HTOAApproFlowSync_OUTServiceStub.WLPS_SY_Main();
                param.setZzpdjg(zzpdjg);
                param.setWorkflowid(workFlowId);
                param.setFxzt(fxzt);
                param.setRequestName(requestName);
                param.setRequestid(requestId);
                param.setCreator(rsCom.getWorkcode(creatorId));
                param.setPlaceholder1(yyfx);
                param.setPlaceholder2(jzcs);
                param.setPlaceholder3(psyj);
                ResourceComInfo rc = I18nContextUtil.getBean(ResourceComInfo.class);
                logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "明细表开始"));
                DetailTable[] detailtable = requestInfo.getDetailTableInfo().getDetailTable();
                if (detailtable != null && detailtable.length > 0) {
                    DetailTable dtq = detailtable[0];
                    Row[] sq = dtq.getRow();
                    for (int j = 0; j < sq.length; j++) {
                        // 指定行
                        Row rq = sq[j];
                        // 每行数据再按列存储
                        Cell[] cq = rq.getCell();
                        JSONObject item = new JSONObject();
                        Map<String, String> mDetailMap = new HashMap<String, String>();
                        for (int k = 0; k < cq.length; k++) {
                            // 指定列
                            Cell cq1 = cq[k];
                            // 明细字段名称
                            String nameq = cq1.getName().toUpperCase();
                            String valueq = Util.null2String(cq1.getValue());
                            mDetailMap.put(nameq, valueq);
                        }
                        String zrr = mDetailMap.get("KHZRE");
                        if (j == 0) {
                            param.setPlaceholder6(rc.getLastname(zrr));
                        }
                        if (j == 1) {
                            param.setPlaceholder7(rc.getLastname(zrr));
                        }
                        if (j == 2) {
                            param.setPlaceholder8(rc.getLastname(zrr));
                        }
                        if (j == 3) {
                            param.setPlaceholder9(rc.getLastname(zrr));
                        }
                        if (j == 4) {
                            param.setPlaceholder10(rc.getLastname(zrr));
                        }
                    }
                }
                logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "明细表结束"));
                // ============================责任人在主表中======================================
                // String[] zrr = tbzrr.split(",");
                // for(int i=0;i<zrr.length&&i<5;i++){
                // if(i==0){
                // param.setPlaceholder6(rc.getLastname(zrr[i]));
                // }
                // if(i==1){
                // param.setPlaceholder7(rc.getLastname(zrr[i]));
                // }
                // if(i==2){
                // param.setPlaceholder8(rc.getLastname(zrr[i]));
                // }
                // if(i==3){
                // param.setPlaceholder9(rc.getLastname(zrr[i]));
                // }
                // if(i==4){
                // param.setPlaceholder10(rc.getLastname(zrr[i]));
                // }
                // }
                // ========================================================================
                mainData.addWLPS_SY_Main(param);
                req.setSYSID("SYS073");
                req.setSENDID(uuid);
                req.setITFID("HT01ETS009");
                req.setDATAS(mainData);
                logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "|SYS073"));
                String[] ret = service.returnRes(req);
                logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "--return--" + ret[0] + "|" + ret[1]));
                if ("E".equals(ret[0])) {
                    RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                    String sql = "update " + tablename + " set state='" + ret[0] + "',message='" + ret[1] + "' where requestId=" + requestId;
                    String poolname_vb = CONN_TYPE.workflow.getType();
                    // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                    rs.executeSql(sql, poolname_vb);
                }
                logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "执行结束"));
            } catch (Exception exception) {
                logger_f1407471.info(String.valueOf("HTLLUnqualifiedApprovalAction--" + requestId + "执行出错：" + exception.getMessage()));
                RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                String sql = "update " + tablename + " set state='E',message='" + exception.getMessage() + "' where requestId=" + requestId;
                String poolname = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs.executeSql(sql, poolname);
            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestInfo.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_f1407471.error("HTLLUnqualifiedApprovalAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), requestInfo.getRequestManager())), requestInfo.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
