package com.weaver.seconddev.interfaces.workflow.action;

import  com.weaver.seconddev.interfaces.easoa.InterLoanService;
import  com.weaver.seconddev.interfaces.easoa.SI_InterLoanApplicationSync_OUTServiceStub.InternalBorrowing;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_InterLoanAction")
public class InterLoanAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_6e218223 = LoggerFactory.getLogger(InterLoanAction.class);

    private static final char[] RMB_NUMS = "零壹贰叁肆伍陆柒捌玖".toCharArray();

    private static final String[] UNITS = { "元", "角", "分", "整" };

    private static final String[] U1 = { "", "拾", "佰", "仟" };

    private static final String[] U2 = { "", "万", "亿" };

    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = request.getRequestid();
            String lcbh = "";
            String title = request.getRequestManager().getRequestname();
            String type = "";
            String sqr = "";
            String sqbm = "";
            String sqdw = "";
            String sqrq = "";
            String sqsj = "";
            String jkdw = "";
            String jcdw = "";
            String kjcye = "";
            String kjdye = "";
            String jkjexx = "";
            String ll = "";
            String jkqx = "";
            String jkrq = "";
            String yjhkrq = "";
            String jksy = "";
            try {
                BillFieldUtil util = new BillFieldUtil();
                Property[] properties = request.getMainTableInfo().getProperty();
                for (int i = 0; i < properties.length; i++) {
                    String name = properties[i].getName().toUpperCase();
                    String value = Util.null2String(properties[i].getValue());
                    if ("LCBH".equals(name)) {
                        lcbh = value;
                    }
                    if ("JKLX".equals(name)) {
                        type = Integer.parseInt(value) + 1 + "";
                        logger_6e218223.info(String.valueOf(type));
                    }
                    if ("SQR".equals(name)) {
                        sqr = util.getName(value);
                    }
                    if ("SQBM".equals(name)) {
                        sqbm = util.getDepartmentname(value);
                    }
                    if ("SQDW".equals(name)) {
                        sqdw = util.getSubcompanyname(value);
                    }
                    if ("SQRQ".equals(name)) {
                        sqrq = value;
                    }
                    if ("SQSJ".equals(name)) {
                        sqsj = value;
                    }
                    if ("JKDW".equals(name)) {
                        jkdw = util.getSubcompanyname(value);
                    }
                    if ("JCDW".equals(name)) {
                        jcdw = util.getSubcompanyname(value);
                    }
                    if ("YZGSJKZYE".equals(name)) {
                        kjcye = value;
                    }
                    if ("YJCDWJKYE".equals(name)) {
                        kjdye = value;
                    }
                    if ("JKJE".equals(name)) {
                        jkjexx = value;
                    }
                    if ("JELL".equals(name)) {
                        ll = value;
                    }
                    if ("JKQX".equals(name)) {
                        jkqx = value;
                    }
                    if ("JKRQ".equals(name)) {
                        jkrq = value;
                    }
                    if ("YJHKRQ".equals(name)) {
                        yjhkrq = value;
                    }
                    if ("SQJKSY".equals(name)) {
                        jksy = value;
                    }
                }
                InterLoanService service = new InterLoanService();
                InternalBorrowing[] info = new InternalBorrowing[1];
                InternalBorrowing param = new InternalBorrowing();
                param.setApplicantCompany(sqdw);
                param.setApplicantDept(sqbm);
                param.setApplicantName(sqr);
                param.setApplicantTime(sqrq + " " + sqsj + ":00");
                param.setBorrowTotalBalance(kjdye);
                param.setBorrowUnitCode("");
                param.setBorrowUnitName(jkdw);
                param.setFlowCode(lcbh);
                param.setFlowId(requestid);
                param.setFlowTitle(title);
                param.setFlowType(type);
                param.setInterestRate(ll + "%");
                param.setLendingTotalBalance(kjcye);
                param.setLendingUnitCode("");
                param.setLendingUnitName(jcdw);
                param.setLoanAmount(jkjexx);
                param.setLoanAmountChines(convert(jkjexx));
                logger_6e218223.info(String.valueOf("借款金额大写" + convert(jkjexx)));
                param.setLoanDate(jkrq + " 00:00:00");
                param.setLoanTerm(jkqx);
                param.setReason(jksy);
                param.setRepayDate(yjhkrq + " 00:00:00");
                info[0] = param;
                String[] str = service.call(info);
                logger_6e218223.info(String.valueOf(requestid + "调用报账系统内部借款接口返回值：" + str[0] + "--" + str[1]));
                if (!"1".equals(str[0])) {
                    request.getRequestManager().setMessageid("ERROR");
                    request.getRequestManager().setMessagecontent("报账系统返回错误信息：" + str[1]);
                }
            } catch (Exception e) {
                logger_6e218223.info(String.valueOf(requestid + "调用报账系统内部借款接口返回值：" + e.toString()));
                request.getRequestManager().setMessageid("ERROR");
                request.getRequestManager().setMessagecontent("报账系统返回错误信息：" + e.toString());
            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_6e218223.error("InterLoanAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager())), request.getRequestManager()));
        }
    }

    public static String convert(String amount) throws IllegalArgumentException {
        // 去掉分隔符
        amount = amount.replace(",", "");
        // 整数部分
        String integer = amount.substring(0, amount.indexOf("."));
        // 小数部分
        String fraction = amount.substring(amount.indexOf(".") + 1);
        String result = "";
        if (!integer.equals("0")) {
            // 整数部分
            result += integer2rmb(integer) + UNITS[0];
        }
        if (fraction.equals("00")) {
            // 添加[整]
            result += UNITS[3];
        } else if (fraction.startsWith("0") && integer.equals("0")) {
            // 去掉分前面的[零]
            result += fraction2rmb(fraction).substring(1);
        } else {
            // 小数部分
            result += fraction2rmb(fraction);
        }
        return result;
    }

    // 将金额小数部分转换为中文大写
    private static String fraction2rmb(String fraction) {
        // 角
        char jiao = fraction.charAt(0);
        // 分
        char fen = fraction.charAt(1);
        return (RMB_NUMS[jiao - '0'] + (jiao > '0' ? UNITS[1] : "")) + (fen > '0' ? RMB_NUMS[fen - '0'] + UNITS[2] : "");
    }

    // 将金额整数部分转换为中文大写
    private static String integer2rmb(String integer) {
        StringBuilder buffer = new StringBuilder();
        // 从个位数开始转换
        int i, j;
        for (i = integer.length() - 1, j = 0; i >= 0; i--, j++) {
            char n = integer.charAt(i);
            if (n == '0') {
                // 当n是0且n的右边一位不是0时，插入[零]
                if (i < integer.length() - 1 && integer.charAt(i + 1) != '0') {
                    buffer.append(RMB_NUMS[0]);
                }
                // 插入[万]或者[亿]
                if (j % 4 == 0) {
                    if (i > 0 && integer.charAt(i - 1) != '0' || i > 1 && integer.charAt(i - 2) != '0' || i > 2 && integer.charAt(i - 3) != '0') {
                        buffer.append(U2[j / 4]);
                    }
                }
            } else {
                if (j % 4 == 0) {
                    // 插入[万]或者[亿]
                    buffer.append(U2[j / 4]);
                }
                // 插入[拾]、[佰]或[仟]
                buffer.append(U1[j % 4]);
                // 插入数字
                buffer.append(RMB_NUMS[n - '0']);
            }
        }
        return buffer.reverse().toString();
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
