package com.weaver.seconddev.interfaces.workflow.action;

import com.alibaba.fastjson.JSONObject;
import  com.weaver.seconddev.interfaces.iuroa.SyncDataService;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.util.HashMap;
import java.util.Map;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.hrm.company.SubCompanyComInfo;
import com.weaver.verupgrade.hrm.resource.ResourceComInfo;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_Iur_syncDemand")
public class Iur_syncDemand extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_7ae2ecde = LoggerFactory.getLogger(Iur_syncDemand.class);

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo requestinfo = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = requestinfo.getRequestid();
            String workflowid = requestinfo.getWorkflowid();
            RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
            BillFieldUtil util = new BillFieldUtil();
            String tablename = util.getTablename(workflowid);
            try {
                logger_7ae2ecde.info(String.valueOf("Iur_syncDemand--start:" + requestid));
                Map<String, String> map = new HashMap<String, String>();
                Property[] properties = requestinfo.getMainTableInfo().getProperty();
                for (int i = 0; i < properties.length; i++) {
                    String name = properties[i].getName().toUpperCase();
                    String value = Util.null2String(properties[i].getValue());
                    map.put(name, value);
                }
                JSONObject obj = new JSONObject();
                SubCompanyComInfo com = I18nContextUtil.getBean(SubCompanyComInfo.class);
                ResourceComInfo res = I18nContextUtil.getBean(ResourceComInfo.class);
                obj.put("title", map.get("XMMC"));
                obj.put("organizationName", com.getSubCompanyname(map.get("XQTCDW")));
                obj.put("name", res.getResourcename(map.get("XQTCR")));
                obj.put("userNo", map.get("XQTCRGH"));
                obj.put("phoneNumber", map.get("XQTCRLXFS"));
                if ("8".equals(map.get("JSLYYJ"))) {
                    obj.put("fieldName", util.getselectNameByCol("jslyyj", workflowid, map.get("JSLYYJ")) + "-" + util.getselectNameByCol("qtfl", workflowid, map.get("QTFL")).trim());
                } else {
                    obj.put("fieldName", util.getselectNameByCol("jslyyj", workflowid, map.get("JSLYYJ")) + "-" + util.getselectNameByCol("jslyej", workflowid, map.get("JSLYEJ")));
                }
                obj.put("amount", map.get("NTRJE"));
                obj.put("intendedPartners", map.get("YXHZDW"));
                obj.put("modeOfIntendedCooperation", map.get("HZFS"));
                obj.put("demandBackground", map.get("XQBJ"));
                obj.put("demandPurpose", map.get("XQMD"));
                obj.put("applicationScenarios", map.get("YYCJ"));
                obj.put("performanceIndex", map.get("XNZB"));
                obj.put("expectedResults", map.get("CXYQ"));
                obj.put("requestId", requestid);
                SyncDataService service = new SyncDataService();
                String[] result = service.call(obj, "syncDemand");
                logger_7ae2ecde.info(requestid + "--Iur_syncDemand--data:" + obj.toString());
                logger_7ae2ecde.info(String.valueOf(requestid + "--Iur_syncDemand--info:[" + result[0] + "|" + result[1] + "]"));
                String poolname_ux = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs.executeSql("update " + tablename + " set status='" + result[0] + "',message='" + result[1] + "' where requestId=" + requestid, poolname_ux);
            } catch (Exception e) {
                logger_7ae2ecde.info(String.valueOf("Iur_syncDemand--error:" + e.toString()));
                String poolname = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs.executeSql("update " + tablename + " set status='E',message='" + e.toString() + "' where requestId=" + requestid, poolname);
            }
            logger_7ae2ecde.info(String.valueOf("Iur_syncDemand--end:" + requestid));
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestinfo.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_7ae2ecde.error("Iur_syncDemand e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), requestinfo.getRequestManager())), requestinfo.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
