package com.weaver.seconddev.interfaces.workflow.action;

import org.apache.commons.lang3.StringUtils;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.util.ArrayList;
import java.util.List;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_RandomExpertAction")
public class RandomExpertAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_4d01ce2 = LoggerFactory.getLogger(RandomExpertAction.class);

    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = request.getRequestid();
            logger_4d01ce2.info(String.valueOf("RandomExpertAction--start--" + requestid));
            String workflowid = request.getWorkflowid();
            try {
                BillFieldUtil util = new BillFieldUtil();
                String tablename = util.getTablename(workflowid);
                RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                List<String> list = new ArrayList<String>();
                String poolname = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs.executeSql("select a.user_id from auth_user_role a " + "INNER JOIN employee b on a.user_id=b.id " + // roleid 测试1310，正式1498
                "where a.role_id=1498 and b.personnel_status<4", poolname);
                while (rs.next()) {
                    list.add(rs.getString("resourceid"));
                }
                List<String> hrm = new ArrayList<String>();
                for (; hrm.size() < 5; ) {
                    int index = (int) (Math.random() * list.size());
                    if (!hrm.contains(list.get(index))) {
                        hrm.add(list.get(index));
                    }
                }
                String userids = StringUtils.join(hrm.toArray(), ",");
                String poolname_tf = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs.executeSql("update " + tablename + " set zj='" + userids + "' where requestid=" + requestid, poolname_tf);
                logger_4d01ce2.info(String.valueOf("RandomExpertAction--end--" + requestid));
            } catch (Exception e) {
                logger_4d01ce2.info(String.valueOf(requestid + "--RandomExpertAction--error--" + e.toString()));
            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_4d01ce2.error("RandomExpertAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager())), request.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
