package com.weaver.seconddev.interfaces.workflow.action;

import com.weaver.common.distribution.genid.IdGenerator;
import  com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_RotationMonthlyEvaluationAction")
public class RotationMonthlyEvaluationAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_5c3e7042 = LoggerFactory.getLogger(RotationMonthlyEvaluationAction.class);

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo requestinfo = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = requestinfo.getRequestid();
            logger_5c3e7042.info(String.valueOf("RotationMonthlyEvaluationAction-start-" + requestid));
            String workflowid = requestinfo.getWorkflowid();
            BillFieldUtil util = new BillFieldUtil();
            String tablename = util.getTablename(workflowid);
            String ksrq = "";
            String jsrq = "";
            Property[] properties = requestinfo.getMainTableInfo().getProperty();
            for (int i = 0; i < properties.length; i++) {
                String name = properties[i].getName().toUpperCase();
                String value = Util.null2String(properties[i].getValue());
                if ("LGLGKSRQ".equals(name)) {
                    ksrq = value;
                }
                if ("LGLGJSRQ".equals(name)) {
                    jsrq = value;
                }
            }
            if (!"".equals(ksrq) && !"".equals(jsrq)) {
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                try {
                    Date startDate = sdf.parse(ksrq);
                    Date endDate = sdf.parse(jsrq);
                    if (!startDate.before(endDate)) {
                        requestinfo.getRequestManager().setMessageid("ERROR");
                        requestinfo.getRequestManager().setMessagecontent("轮岗开始日期需小于轮岗结束日期");
                        return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestinfo.getRequestManager()));
                    }
                    Calendar c = Calendar.getInstance();
                    c.setTime(endDate);
                    int endY = c.get(Calendar.YEAR);
                    int endMon = c.get(Calendar.MONTH);
                    c.setTime(startDate);
                    int startY = c.get(Calendar.YEAR);
                    int startMon = c.get(Calendar.MONTH);
                    int diff = 0;
                    if (startY == endY) {
                        diff = endMon - startMon;
                    } else if (endY > startY) {
                        diff = (endY - startY) * 12 + endMon - startMon;
                    }
                    List<String> list = new ArrayList<String>();
                    RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                    String get_id = "select id from " + tablename + " where requestId=" + requestid;
                    String poolname = CONN_TYPE.workflow.getType();
                    // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                    rs.executeSql(get_id, poolname);
                    String id = "";
                    if (rs.next()) {
                        id = rs.getString("id");
                    }
                    for (int i = 0; i < diff + 1; i++) {
                        c.setTime(startDate);
                        c.add(Calendar.MONTH, (i + 1));
                        Date midDate = c.getTime();
                        if (!midDate.after(endDate)) {
                            list.add(sdf.format(midDate));
                            String sql = "insert into " + tablename + "_dt2(mainid,lgpjrq) values(" + id + ",'" + sdf.format(midDate) + "')";
                            String poolname_x5 = CONN_TYPE.workflow.getType();
                            /* *TODO  检测到insert语句 -> E9插入sql迁移到E10需要特殊处理请参考文档进行调整  https://www.e-cology.com.cn/sp/doc/docShare/1027709301045985331?tenantKey=t7akvdnf84
 TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源*/
                            long generate = IdGenerator.generate();
                            rs.executeSql(sql, poolname_x5,generate);
                            logger_5c3e7042.info(String.valueOf("RotationMonthlyEvaluationAction-info-" + requestid + "-[" + sql + "]"));
                        } else {
                            break;
                        }
                    }
                } catch (Exception e) {
                    logger_5c3e7042.info(String.valueOf("RotationMonthlyEvaluationAction-error-" + requestid + "-[" + e.toString() + "]"));
                }
            }
            logger_5c3e7042.info(String.valueOf("RotationMonthlyEvaluationAction-end-" + requestid));
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestinfo.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_5c3e7042.error("RotationMonthlyEvaluationAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), requestinfo.getRequestManager())), requestinfo.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
