package com.weaver.seconddev.interfaces.workflow.action;

import java.text.SimpleDateFormat;
import java.util.*;

import com.weaver.common.distribution.genid.IdGenerator;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import org.springframework.core.env.Environment;
import java.lang.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.formmode.setup.ModeRightInfo;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.soa.workflow.request.*;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.soa.workflow.request.DetailTable;
import com.weaver.verupgrade.soa.workflow.request.Row;
import com.weaver.verupgrade.soa.workflow.request.Cell;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_WuJangGiftStorageAction")
public class WuJangGiftStorageAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_3c4594 = LoggerFactory.getLogger(WuJangGiftStorageAction.class);

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo requestinfo = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = requestinfo.getRequestid();
            logger_3c4594.info(String.valueOf("WuJangGiftStorageAction--start--" + requestid));
            try {
                String sqr = "";
                // 获取表单主字段信息
                Property[] properties = requestinfo.getMainTableInfo().getProperty();
                for (int i = 0; i < properties.length; i++) {
                    // 主表数据
                    // 字段名
                    String name = properties[i].getName().toUpperCase();
                    // 值
                    String value = Util.null2String(properties[i].getValue());
                    if ("SQR".equals(name)) {
                        sqr = value;
                    }
                }
                // XZ011只有配置里维护的人申请才触发接口
                String creator = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htxzsetting.creator"));
                if (creator.indexOf(sqr) >= 0) {
                    DetailTable dtq = requestinfo.getDetailTableInfo().getDetailTable(0);
                    Row[] sq = dtq.getRow();
                    List<Map<String, String>> list = new ArrayList<Map<String, String>>();
                    for (int j = 0; j < sq.length; j++) {
                        Row rq = sq[j];
                        Cell[] cq = rq.getCell();
                        Map<String, String> map = new HashMap<String, String>();
                        for (int k = 0; k < cq.length; k++) {
                            Cell cq1 = cq[k];
                            String nameq = cq1.getName().toLowerCase();
                            String valueq = Util.null2String(cq1.getValue());
                            map.put(nameq, valueq);
                        }
                        list.add(map);
                    }
                    Date date = new Date();
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    String rq = sdf.format(date).split(" ")[0];
                    String sj = sdf.format(date).split(" ")[1];
                    RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                    for (int i = 0; i < list.size(); i++) {
                        String lx = list.get(i).get("lx");
                        if ("0".equals(lx)) {
                            if ("0".equals(list.get(i).get("xqqr"))) {
                                insertData(sqr, list.get(i).get("pm"), list.get(i).get("ggxh"), list.get(i).get("pp"), list.get(i).get("rksl"), list.get(i).get("dw"), list.get(i).get("ygdj"), list.get(i).get("lplx"), list.get(i).get("lpbm"), rq, sj);
                            } else {
                                insertData(sqr, list.get(i).get("sjpm"), list.get(i).get("ggxh2"), list.get(i).get("pp2"), list.get(i).get("sjshsl"), list.get(i).get("sjdw"), list.get(i).get("sjygjg"), list.get(i).get("sjlplx"), list.get(i).get("sjlpbm"), rq, sj);
                            }
                        } else if ("1".equals(lx)) {
                            // 入库数量
                            String rksl = "";
                            if ("0".equals(list.get(i).get("xqqr"))) {
                                rksl = list.get(i).get("rksl");
                            } else {
                                rksl = list.get(i).get("sjshsl");
                            }
                            String sql = "update formtable_main_206 set kcsl=isnull(kcsl,0)+'" + rksl + "' where id=" + list.get(i).get("lpxx");
                            logger_3c4594.info(String.valueOf(sql));
                            String poolname = CONN_TYPE.workflow.getType();
                            // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                            rs.executeSql(sql, poolname);
                        }
                    }
                    ModeRightInfo ModeRightInfo = I18nContextUtil.getBean(ModeRightInfo.class);
                    // TODO e10 该方法已废弃
                    ModeRightInfo.setNewRight(true);
                    String right_sql = "select id from formtable_main_206 where modedatacreatedate='" + rq + "' and modedatacreatetime='" + sj + "'";
                    logger_3c4594.info(String.valueOf(right_sql));
                    String poolname_bm = CONN_TYPE.workflow.getType();
                    // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                    rs.executeSql(right_sql, poolname_bm);
                    while (rs.next()) {
                        Long id = (long) rs.getInt("id");
                        /* TODO 方法参数:Integer.parseInt(sqr) 类型发生变化 e9类型:int e10类型:long
 TODO 方法参数:10 类型发生变化 e9类型:int e10类型:long
 TODO 方法参数:id 类型发生变化 e9类型:int e10类型:long
 TODO // 创建人字段已废弃 默认是用billid 数据对应的数据创建人*/
                        ModeRightInfo.editModeDataShare(Integer.parseInt(sqr), 10, id);
                    }
                }
            } catch (Exception e) {
                logger_3c4594.info(String.valueOf("WuJangGiftStorageAction--" + requestid + "--error--" + e.toString()));
            }
            logger_3c4594.info(String.valueOf("WuJangGiftStorageAction--end--" + requestid));
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestinfo.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_3c4594.error("WuJangGiftStorageAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), requestinfo.getRequestManager())), requestinfo.getRequestManager()));
        }
    }

    public void insertData(String creator, String pm, String ggxh, String pp, String kcsl, String dw, String ygdj, String lplx, String lpbm, String rq, String sj) {
        String sql = "insert into formtable_main_206(formmodeid,modedatacreater,modedatacreatertype,modedatacreatedate,modedatacreatetime,lplx,pm,pp,ggxh,dw,dj,lpbm,kcsl,sfqy) values(" + "10,'" + creator + "',0,'" + rq + "','" + sj + "'," + lplx + ",'" + pm + "','" + pp + "','" + ggxh + "','" + dw + "','" + ygdj + "','" + lpbm + "','" + kcsl + "',0 )";
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
        logger_3c4594.info(String.valueOf(sql));
        String poolname_n1 = CONN_TYPE.workflow.getType();
        /* *TODO  检测到insert语句 -> E9插入sql迁移到E10需要特殊处理请参考文档进行调整  https://www.e-cology.com.cn/sp/doc/docShare/1027709301045985331?tenantKey=t7akvdnf84
 TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源*/
        long generate = IdGenerator.generate();
        rs.executeSql(sql, poolname_n1,generate);
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
